Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | File List | Class Members | File Members

# DL_GroupParameters_DSA Class Reference

`#include <gfpcrypt.h>`

Inheritance diagram for DL_GroupParameters_DSA:

List of all members.

## Detailed Description

DSA group parameters, these are GF(p) group parameters that are allowed by the DSA standard.

Definition at line 364 of file gfpcrypt.h.

## Public Types
typedef ModExpPrecomputation::Element | Element
typedef ModExpPrecomputation | GroupPrecomputation
typedef DL_FixedBasePrecomputationImpl< typenameModExpPrecomputation::Element > | BasePrecomputation
## Public Member Functions
bool | ValidateGroup (RandomNumberGenerator &rng, unsigned int level) const
void | GenerateRandom (RandomNumberGenerator &rng, const NameValuePairs &alg)
bool | IsIdentity (const Integer &element) const
virtual bool | IsIdentity (const Element &element) const=0
void | SimultaneousExponentiate (Element *results, const Element &base, const Integer *exponents, unsigned int exponentsCount) const
bool | GetVoidValue (const char *name, const std::type_info &valueType, void *pValue) const
| to be implemented by derived classes, users should use one of the above functions instead
Element | MultiplyElements (const Element &a, const Element &b) const
Element | CascadeExponentiate (const Element &element1, const Integer &exponent1, const Element &element2, const Integer &exponent2) const
void | AssignFrom (const NameValuePairs &source)
| assign values from source to this object
const DL_FixedBasePrecomputation< Element > & | GetBasePrecomputation () const
DL_FixedBasePrecomputation< Element > & | AccessBasePrecomputation ()
const Integer & | GetModulus () const
const Integer & | GetGenerator () const
void | SetModulusAndSubgroupGenerator (const Integer &p, const Integer &g)
bool | operator== (const DL_GroupParameters_IntegerBasedImpl< ModExpPrecomputation, DL_FixedBasePrecomputationImpl< typenameModExpPrecomputation::Element > > &rhs) const
bool | operator!= (const DL_GroupParameters_IntegerBasedImpl< ModExpPrecomputation, DL_FixedBasePrecomputationImpl< typenameModExpPrecomputation::Element > > &rhs) const
const DL_GroupPrecomputation< Element > & | GetGroupPrecomputation () const
void | Initialize (const DL_GroupParameters_IntegerBased &params)
void | Initialize (RandomNumberGenerator &rng, unsigned int pbits)
void | Initialize (const Integer &p, const Integer &g)
void | Initialize (const Integer &p, const Integer &q, const Integer &g)
void | BERDecode (BufferedTransformation &bt)
| decode this object from a BufferedTransformation, using BER (Basic Encoding Rules)
void | DEREncode (BufferedTransformation &bt) const
| encode this object into a BufferedTransformation, using DER (Distinguished Encoding Rules)
const Integer & | GetSubgroupOrder () const
Integer | GetGroupOrder () const
bool | ValidateElement (unsigned int level, const Integer &element, const DL_FixedBasePrecomputation< Integer > *precomp) const
virtual bool | ValidateElement (unsigned int level, const Element &element, const DL_FixedBasePrecomputation< Element > *precomp) const=0
bool | FastSubgroupCheckAvailable () const
void | EncodeElement (bool reversible, const Element &element, byte *encoded) const
unsigned int | GetEncodedElementSize (bool reversible) const
Integer | DecodeElement (const byte *encoded, bool checkForGroupMembership) const
Integer | ConvertElementToInteger (const Element &element) const
Integer | GetMaxExponent () const
OID | GetAlgorithmID () const
void | SetSubgroupOrder (const Integer &q)
bool | Validate (RandomNumberGenerator &rng, unsigned int level) const
| check this object for errors
bool | SupportsPrecomputation () const
| whether this object supports precomputation
void | Precompute (unsigned int precomputationStorage=16)
| do precomputation
void | LoadPrecomputation (BufferedTransformation &storedPrecomputation)
| retrieve previously saved precomputation
void | SavePrecomputation (BufferedTransformation &storedPrecomputation) const
| save precomputation for later use
virtual const Element & | GetSubgroupGenerator () const
virtual void | SetSubgroupGenerator (const Element &base)
virtual Element | ExponentiateBase (const Integer &exponent) const
virtual Element | ExponentiateElement (const Element &base, const Integer &exponent) const
virtual Integer | GetCofactor () const
void | GenerateRandomWithKeySize (RandomNumberGenerator &rng, unsigned int keySize)
| calls the above function with a NameValuePairs object that just specifies "KeySize"
virtual void | ThrowIfInvalid (RandomNumberGenerator &rng, unsigned int level) const
| throws InvalidMaterial if this object fails Validate() test
virtual void | Save (BufferedTransformation &bt) const
| save key into a BufferedTransformation
void | Save (BufferedTransformation &bt) const
| save key into a BufferedTransformation
virtual void | Load (BufferedTransformation &bt)
| load key from a BufferedTransformation
void | Load (BufferedTransformation &bt)
| load key from a BufferedTransformation
void | DoQuickSanityCheck () const
template<class T> bool | GetThisObject (T &object) const
| get a copy of this object or a subobject of it
template<class T> bool | GetThisPointer (T *&p) const
| get a pointer to this object, as a pointer to T
template<class T> bool | GetValue (const char *name, T &value) const
| get a named value, returns true if the name exists
template<class T> T | GetValueWithDefault (const char *name, T defaultValue) const
| get a named value, returns the default if the name doesn't exist
std::string | GetValueNames () const
| get a list of value names that can be retrieved
bool | GetIntValue (const char *name, int &value) const
| get a named value with type int
int | GetIntValueWithDefault (const char *name, int defaultValue) const
| get a named value with type int, with default
template<class T> void | GetRequiredParameter (const char *className, const char *name, T &value) const
void | GetRequiredIntParameter (const char *className, const char *name, int &value) const
virtual void | BEREncode (BufferedTransformation &bt) const
| encode this object into a BufferedTransformation, using BER
## Static Public Member Functions
std::string | StaticAlgorithmNamePrefix ()
void | ThrowIfTypeMismatch (const char *name, const std::type_info &stored, const std::type_info &retrieving)
| used by derived classes to check for type mismatch
## Protected Member Functions
int | GetFieldType () const
Integer | ComputeGroupOrder (const Integer &modulus) const
virtual unsigned int | GetDefaultSubgroupOrderSize (unsigned int modulusSize) const
void | ParametersChanged ()
## Protected Attributes
ModExpPrecomputation | m_groupPrecomputation
DL_FixedBasePrecomputationImpl< typenameModExpPrecomputation::Element > | m_gpc

## Member Function Documentation

bool DL_GroupParameters_DSA::ValidateGroup | ( | RandomNumberGenerator & | rng,
|  | unsigned int | level
| ) | const`[virtual]`

| also checks that the lengths of p and q are allowed by the DSA standard Reimplemented from DL_GroupParameters_IntegerBased. Definition at line 61 of file gfpcrypt.cpp. References Integer::BitCount().

void DL_GroupParameters_DSA::GenerateRandom | ( | RandomNumberGenerator & | rng,
|  | const NameValuePairs & | alg
| ) | `[virtual]`

| ModulusSize must be between DSA::MIN_PRIME_LENGTH and DSA::MAX_PRIME_LENGTH, and divisible by DSA::PRIME_LENGTH_MULTIPLE Reimplemented from DL_GroupParameters_IntegerBased. Definition at line 26 of file gfpcrypt.cpp. References RandomNumberGenerator::GenerateBlock(), DSA::GeneratePrimes(), NameValuePairs::GetIntValue(), NameValuePairs::GetValue(), and NameValuePairs::GetValueWithDefault().

void DL_GroupParameters_IntegerBasedImpl< ModExpPrecomputation , DL_FixedBasePrecomputationImpl< typename ModExpPrecomputation ::Element> >::AssignFrom | ( | const NameValuePairs & | source | ) | `[inline, virtual, inherited]`

| assign values from source to this object Note: This function can be used to create a public key from a private key. Reimplemented from DL_GroupParameters_IntegerBased. Definition at line 95 of file gfpcrypt.h.

bool DL_GroupParameters< Integer >::Validate | ( | RandomNumberGenerator & | rng,
|  | unsigned int | level
| ) | const`[inline, virtual, inherited]`

  | check this object for errors Parameters:
  | level | denotes the level of thoroughness: 0 - using this object won't cause a crash or exception (rng is ignored) 1 - this object will probably function (encrypt, sign, etc.) correctly (but may not check for weak keys and such) 2 - make sure this object will function correctly, and do reasonable security checks 3 - do checks that may take a long time
Returns: true if the tests pass Implements CryptoMaterial. Definition at line 551 of file pubkey.h.

void DL_GroupParameters< Integer >::Precompute | ( | unsigned int | precomputationStorage = `16` | ) | `[inline, virtual, inherited]`

| do precomputation The exact semantics of Precompute() is varies, but typically it means calculate a table of n objects that can be used later to speed up computation. Reimplemented from CryptoMaterial. Definition at line 577 of file pubkey.h.

virtual void CryptoMaterial::Load | ( | BufferedTransformation & | bt | ) | `[inline, virtual, inherited]`

  | load key from a BufferedTransformation Exceptions:
  | KeyingErr | if decode fails
Note: Generally does not check that the key is valid. Call ValidateKey() or ThrowIfInvalidKey() to check that. Reimplemented in ASN1CryptoMaterial. Definition at line 994 of file cryptlib.h.

void ASN1CryptoMaterial::Load | ( | BufferedTransformation & | bt | ) | `[inline, virtual, inherited]`

  | load key from a BufferedTransformation Exceptions:
  | KeyingErr | if decode fails
Note: Generally does not check that the key is valid. Call ValidateKey() or ThrowIfInvalidKey() to check that. Reimplemented from CryptoMaterial. Definition at line 52 of file simple.h. References ASN1Object::BERDecode().

bool NameValuePairs::GetIntValue | ( | const char * | name,
|  | int & | value
| ) | const`[inline, inherited]`

| get a named value with type int used to ensure we don't accidentally try to get an unsigned int or some other type when we mean int (which is the most common case) Definition at line 278 of file cryptlib.h. Referenced by InvertibleRWFunction::GenerateRandom(), InvertibleRSAFunction::GenerateRandom(), InvertibleRabinFunction::GenerateRandom(), InvertibleLUCFunction::GenerateRandom(), DL_GroupParameters_IntegerBased::GenerateRandom(), GenerateRandom(), and InvertibleESIGNFunction::GenerateRandom().

virtual void ASN1Object::BEREncode | ( | BufferedTransformation & | bt | ) | const`[inline, virtual, inherited]`

| encode this object into a BufferedTransformation, using BER this may be useful if DEREncode() would be too inefficient Definition at line 1561 of file cryptlib.h. Referenced by ASN1CryptoMaterial::Save().

The documentation for this class was generated from the following files:

- gfpcrypt.h
- gfpcrypt.cpp